SystemOrganization addCategory: #'Orca-Testing'!

TestResult subclass: #OrcaTestResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaTestResult methodsFor: 'accessing' stamp: 'sw 5/17/2011 14:41'!
erroneousTestcases

	^ errors! !

!OrcaTestResult methodsFor: 'accessing' stamp: 'sw 5/17/2011 14:42'!
failedTestcases

	^ failures! !

!OrcaTestResult methodsFor: 'initialization' stamp: 'sw 5/17/2011 14:39'!
initialize
	super initialize.
	failures := OrderedCollection new.
	! !

!OrcaTestResult methodsFor: 'accessing' stamp: 'sw 5/17/2011 14:41'!
passedTestcases

	^ passed! !

Object subclass: #OrcaMock
	instanceVariableNames: 'mockedObject receivedMessages stubbedMessages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaMock class methodsFor: 'instance creation' stamp: 'hk 5/3/2011 07:46'!
for: anObject

	^ self new mockedObject: anObject! !

!OrcaMock methodsFor: 'mocking' stamp: 'hk 5/3/2011 09:43'!
doesNotUnderstand: aMessage

	self receivedMessages add: aMessage.
	(self stubs: aMessage)
		ifTrue: [ ^ (self stubbedMessages at: aMessage selector) value ]
		ifFalse: [ aMessage sendTo: self mockedObject ].! !

!OrcaMock methodsFor: 'initialization' stamp: 'hk 5/3/2011 09:37'!
initialize

	self
		receivedMessages: OrderedCollection new;
		stubbedMessages: Dictionary new.! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 07:46'!
mockedObject
	^ mockedObject! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 07:46'!
mockedObject: anObject
	mockedObject := anObject! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 08:20'!
received: aMessage

	self assert: aMessage isSymbol.
	^ self received: aMessage atLeast: 1! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 08:10'!
received: aMessage atLeast: aNumber

	self assert: aMessage isSymbol.
	^ (self receivedMessages select: [ :each | each selector = aMessage]) size >= aNumber! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 08:21'!
received: aMessage atMost: aNumber

	self assert: aMessage isSymbol.
	^ (self receivedMessages select: [ :each | each selector = aMessage]) size <= aNumber! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 08:11'!
received: aMessage times: aNumber

	self assert: aMessage isSymbol.
	^ (self receivedMessages select: [ :each | each selector = aMessage]) size = aNumber! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 10:20'!
received: aMessage withArgs: arguments

	self assert: aMessage isSymbol.
	^ (self receivedMessages select: [ :each |
		each selector = aMessage
		and: [ each arguments = arguments ]
		]) notEmpty! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 07:58'!
receivedMessages
	^ receivedMessages! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 07:58'!
receivedMessages: anObject
	receivedMessages := anObject! !

!OrcaMock methodsFor: 'stubbing' stamp: 'hk 5/3/2011 09:38'!
stub: aMessage

	self stubbedMessages at: aMessage put: nil.! !

!OrcaMock methodsFor: 'stubbing' stamp: 'hk 5/3/2011 09:40'!
stub: aMessage andReturn: aBlock

	self stubbedMessages at: aMessage put: aBlock.! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 09:37'!
stubbedMessages
	^ stubbedMessages! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 09:37'!
stubbedMessages: anObject
	stubbedMessages := anObject! !

!OrcaMock methodsFor: 'stubbing' stamp: 'hk 5/3/2011 09:42'!
stubs: aMessage

	^ self stubbedMessages includesKey: aMessage selector! !

!OrcaMock methodsFor: 'mocking' stamp: 'hk 5/3/2011 07:57'!
unmock

	| temp |
	temp := self mockedObject.
	self mockedObject: nil.
	self become: temp.! !

Object subclass: #OrcaTestRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

OrcaTestRunner class
	instanceVariableNames: 'dispatcher tests clientConnectionSemaphore'!

OrcaTestRunner class
	instanceVariableNames: 'dispatcher tests clientConnectionSemaphore'!

!OrcaTestRunner class methodsFor: 'accessing' stamp: 'sw 5/16/2011 09:27'!
clientConnectionSemaphore
	^ clientConnectionSemaphore! !

!OrcaTestRunner class methodsFor: 'accessing' stamp: 'sw 5/16/2011 09:27'!
clientConnectionSemaphore: anObject
	clientConnectionSemaphore := anObject! !

!OrcaTestRunner class methodsFor: 'accessing' stamp: 'sw 5/3/2011 14:07'!
dispatcher
	^ dispatcher! !

!OrcaTestRunner class methodsFor: 'accessing' stamp: 'sw 5/3/2011 14:07'!
dispatcher: anObject
	dispatcher := anObject! !

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2011 13:45'!
ensureClientSideTestRunnerIsStarted

	| activeSessions |
	
	self dispatcher ifNil:  [ self startDispatcher ].
		
	activeSessions := OrcaClientSideTestSession allInstances 
		select: [ :each |
			each channel notNil and: [ each channel isAlive] 
		].
		
	activeSessions	isEmpty ifTrue:
		[ self runFireFox ].
	
	
	   
	
		
	! !

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2011 15:06'!
isOrcaRootComponent
	
	^ true! !

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'sw 5/3/2011 14:48'!
killFireFox

	CommandShell command: 'osascript -e ''tell application "Firefox" to quit'''
! !

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'sw 5/11/2011 12:24'!
orcaSessionClass 

	 ^OrcaClientSideTestSession! !

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2011 15:06'!
orcaTitle
	
	^ 'Testing is fun'! !

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2011 16:16'!
requiredClasses
	
	^ (OrcaClientSideTest allSubclasses union: (OrcaWidget allSubclasses )) union: { Dictionary . OrcaTestResult}! !

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 15:42'!
reset

	OrcaClientSideTestSession allInstancesDo: [ :each | each channel ifNotNil: [ each channel  released ] ].
	self stopDispatcher; 
		startDispatcher. 
! !

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2011 09:49'!
runFireFox

"	CommandShell command: 'open /Applications/Firefox.app --args http://localhost:', OrcaTestRunner testPort , '/',  OrcaTestRunner uniquePath , '; exit'"
	CommandShell command: 'open  ''http://localhost:', OrcaTestRunner testPort , '/',  OrcaTestRunner uniquePath , '''; exit'.
	
	self clientConnectionSemaphore: Semaphore new.
	(self clientConnectionSemaphore waitTimeoutSeconds: self secondsToWait) ifTrue: [
		" the Semaphore wasn't signaled" 
		Error signal: 'The Browser isn''t responding' ].! !

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2011 09:29'!
secondsToWait

	^ 60
	
		
	! !

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2011 11:09'!
start

	Js Global st DEBUG: false.
	Js Global testRunner: (OrcaClientSideTestRunner new addToWorld;
									yourself)
	! !

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2011 13:36'!
startDispatcher
	
	Transcript show: 'The TestRunner Dispatcher is starting'; cr.
	self dispatcher: (OrcaDispatcher installOn: self testPort  withName: self name ).
	(OrcaDispatcher siteNamed: self name ) start   
	! !

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'sw 5/10/2011 14:10'!
stopDispatcher
	
	Transcript show: 'The TestRunner Dispatcher is stopping'; cr.
	self dispatcher: nil.
	SwazooServer singleton removeSite: (OrcaDispatcher siteNamed: self name)! !

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'sw 5/3/2011 15:47'!
test: aClass selector: aSymbol

	self dispatcher 
		ifNil: [ self startDispatcher ].
	
	self tests: Dictionary new.
	self tests at: (aClass name) put: { aSymbol }.
	self runFireFox.
	

	"self stopDispatcher."! !

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 09:37'!
testPort

	^ 8886! !

!OrcaTestRunner class methodsFor: 'accessing' stamp: 'sw 5/3/2011 15:44'!
tests

	tests ifNil: [ self tests: Dictionary new ].
	^ tests! !

!OrcaTestRunner class methodsFor: 'accessing' stamp: 'sw 5/3/2011 14:45'!
tests: anObject
	tests := anObject! !

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2011 15:06'!
uniquePath

	^ 'testing'! !

OrcaSession subclass: #OrcaClientSideTestSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaClientSideTestSession methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2011 09:42'!
handleChannelOpened

	super handleChannelOpened.
	OrcaTestRunner clientConnectionSemaphore signal.! !

TestCase subclass: #OrcaClientSideTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaClientSideTest class methodsFor: 'configuration' stamp: 'sw 5/3/2011 14:59'!
requiredClasses

	^ { TestResult }! !

!OrcaClientSideTest class methodsFor: 'configuration' stamp: 'sw 5/10/2011 14:41'!
suiteClass

	 ^ OrcaClientSideTestSuite ! !

!OrcaClientSideTest methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 15:29'!
debug

	Error signal: 'An failure or Error was thrown while testing - see the browser for details!!!! '! !

!OrcaClientSideTest methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 15:29'!
run
	"this method will be called  in the image when executing single tests (e.g. in the class browser when test a method)"

	
	OrcaTestRunner ensureClientSideTestRunnerIsStarted.
	OrcaClientSideTestSession allInstancesDo: 
		[ :each |
			[ :aDictionary | Js Global testRunner executeTests: aDictionary ] inSession:  each values: { {(self class name ->  self selector )} }.
		].
	
	^ OrcaClientSideTestRunner waitForTestsResults! !

!OrcaClientSideTest methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2011 16:02'!
runInClientside
	| result |
	"this method will be invoked in the client to execute the tests"
	
	result := OrcaTestResult new.
	self run: result.
	^ result
	! !

!OrcaClientSideTest methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 14:54'!
timeout 

	 ^ 60! !

!OrcaClientSideTest methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 14:54'!
timeoutForSetUp 

	 ^ 60*1000! !

!OrcaClientSideTest methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 14:54'!
timeoutForTest

	 ^ 60*1000! !

OrcaClientSideTest subclass: #OrcaFailingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaFailingTest methodsFor: 'as yet unclassified' stamp: 'sw 5/10/2011 14:36'!
testError

	self fail.! !

!OrcaFailingTest methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 15:27'!
testFail

	"self should: [ Foo bar ] raise: Error."! !

!OrcaFailingTest methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 15:00'!
testPass
	
	self assert:true! !

!OrcaFailingTest methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2011 10:08'!
testSimpleFail
	self assert:false! !

OrcaClientSideTest subclass: #OrcaWidgetDomTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaWidgetDomTest methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2011 16:42'!
run

	self
		setUp;
		testText;
		testDomPresence;
		tearDown.! !

!OrcaWidgetDomTest methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2011 14:14'!
setUp

	OrcaText new
		text: 'Hello World';
		addToWorld.! !

!OrcaWidgetDomTest methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2011 16:38'!
tearDown

	Js Global alert value: 'I am done!!'.! !

!OrcaWidgetDomTest methodsFor: 'as yet unclassified' stamp: 'sw 5/3/2011 15:07'!
testDomPresence

	"self assert: (self hasElement: 'span')."! !

!OrcaWidgetDomTest methodsFor: 'as yet unclassified' stamp: 'sw 5/3/2011 15:07'!
testText

	"self assert: (self hasText: 'Hello World')."! !

TestCase subclass: #OrcaMockTest
	instanceVariableNames: 'mock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaMockTest methodsFor: 'accessing' stamp: 'hk 5/3/2011 09:45'!
mock
	^ mock! !

!OrcaMockTest methodsFor: 'accessing' stamp: 'hk 5/3/2011 09:45'!
mock: anObject
	mock := anObject! !

!OrcaMockTest methodsFor: 'as yet unclassified' stamp: 'hk 5/3/2011 09:46'!
setUp

	self mock: (OrcaMock for: (OrderedCollection new)).! !

!OrcaMockTest methodsFor: 'as yet unclassified' stamp: 'hk 5/3/2011 09:46'!
tearDown

	self mock: nil.! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:11'!
testCleanInitialization

	self assert: self mock receivedMessages isEmpty.
	self assert: self mock stubbedMessages isEmpty.! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 09:50'!
testMessageForwarding

	self assert: (self mock stubbedMessages isEmpty).
	self mock add: true.
	self assert: self mock mockedObject size = 1! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 09:48'!
testMockedObject

	self assert: self mock mockedObject isCollection.! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:19'!
testReceived

	self mock add: 1.
	self assert: (self mock received: #add:).
	self assert: (self mock received: #add: withArgs: { 1}).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:22'!
testReceivedAtLeast

	self deny: (self mock received: #add: atLeast: 1).
	self mock add: 1.
	self assert: (self mock received: #add: atLeast: 1).
	self deny: (self mock received: #add: atLeast: 2).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:23'!
testReceivedAtMost

	self assert: (self mock received: #add: atMost: 1).
	self mock
		add: 1;
		add: 2..
	self deny: (self mock received: #add: atMost: 1).
	self assert: (self mock received: #add: atMost: 2).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:23'!
testReceivedTimes

	self deny: (self mock received: #add: times: 1).
	self mock add: 1.
	self assert: (self mock received: #add: times: 1).
	self deny: (self mock received: #add: times: 2).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:17'!
testStubReturnValue

	self mock stub: #add: andReturn: true.
	self assert: (self mock add: 1 = true).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:20'!
testStubReturnsNil

	self mock stub: #add:.
	self assert: ((self mock add: 1) = nil).
	self assert: self mock mockedObject isEmpty.! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:15'!
testStubbedMessages

	self mock stub: #add:.
	self deny: (self mock stubbedMessages isEmpty).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 09:47'!
testUnmock

	self mock unmock.
	self assert: self mock isCollection.! !

TestSuite subclass: #OrcaClientSideTestSuite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaClientSideTestSuite methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 15:26'!
createCollectionOfAssociationsFrom: aCollectionOfTestCases

	| collection |
	collection := OrderedCollection new.
	aCollectionOfTestCases do: [ :each |
		collection add: (each class name -> each selector) ].
	
	^ collection.! !

!OrcaClientSideTestSuite methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 15:26'!
run 
	

	OrcaTestRunner ensureClientSideTestRunnerIsStarted.
	
	tests := self createCollectionOfAssociationsFrom: self tests.
	
	OrcaClientSideTestSession allInstancesDo: 
		[ :each |
			[ :aDictionary | Js Global testRunner executeTests: aDictionary ] inSession: each values: { tests }..
		].
	
	^ OrcaClientSideTestRunner waitForTestsResults! !

!OrcaClientSideTestSuite methodsFor: 'as yet unclassified' stamp: 'sw 5/10/2011 14:53'!
run: aResult 
	"this method will be called when executing a bunch of tests (e.g. of whole classes in the class browser)"
	
	self halt.
	self tests do: [:each | 
		self changed: each.
		each run: aResult].
			! !

OrcaWidget subclass: #OrcaClientSideTestRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

OrcaClientSideTestRunner class
	instanceVariableNames: 'testResults testResultSemaphore'!

OrcaClientSideTestRunner class
	instanceVariableNames: 'testResults testResultSemaphore'!

!OrcaClientSideTestRunner class methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 14:32'!
maxSecondsForTesting
	
	^ 60! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'sw 5/11/2011 11:28'!
testResultSemaphore
	^ testResultSemaphore! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'sw 5/11/2011 11:28'!
testResultSemaphore: anObject
	testResultSemaphore := anObject! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'sw 5/11/2011 12:11'!
testResults
	^ testResults! !

!OrcaClientSideTestRunner class methodsFor: 'accessing' stamp: 'sw 5/17/2011 14:35'!
testResults: anObject

	testResults := anObject.
	self testResultSemaphore signal.
	^ true! !

!OrcaClientSideTestRunner class methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 14:54'!
testResultsFromString
	| result testcase |
	
	result := OrcaTestResult new.
	testcase := OrcaClientSideTest new; selector: #foo.
	
	(self testResults = 'pass') 
		ifTrue: [result passedTestcases add: testcase].
	(self testResults = 'error') 
		ifTrue: [result erroneousTestcases add: testcase].
	(self testResults = 'failure') 
		ifTrue: [result failedTestcases add: testcase].

	^ result

	
	! !

!OrcaClientSideTestRunner class methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 14:35'!
waitForTestsResults
	
	self testResultSemaphore: Semaphore new.
	(self testResultSemaphore waitTimeoutSeconds: self maxSecondsForTesting)
	 	ifTrue: [  Error signal: 'Browser doesn''t answer' ]
		ifFalse: [ ^ self testResultsFromString ]     

	! !

!OrcaClientSideTestRunner methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 15:37'!
executeTests: tests
	| results |
	
	results :=OrderedCollection new.
	tests do: [ :aAssociation |      
		results add: (self test: aAssociation )				
	].
	self sendResults: results.
	self add: (OrcaText new text: '<br/>Results has been sent').  ! !

!OrcaClientSideTestRunner methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 15:35'!
initialize

	super initialize.
	self add: (OrcaHeading new text: 'Test Runner').
! !

!OrcaClientSideTestRunner methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 15:35'!
resultStringFor: aTestResult
	| resultString |
	
	resultString:= 'pass'.	
	aTestResult hasFailures ifTrue: [
		resultString := 'failure'].
	aTestResult hasErrors ifTrue: [
		resultString := 'error'].
	^ resultString
	  
	! !

!OrcaClientSideTestRunner methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 15:33'!
sendResults: results

	[ :testResults | OrcaClientSideTestRunner testResults: testResults ] onServer value: (self resultStringFor: results first).
	! !

!OrcaClientSideTestRunner methodsFor: 'as yet unclassified' stamp: 'sw 5/17/2011 15:37'!
test: aAssociation 
	| result testcase |

	testcase :=   ((Js instanceFromClassNamed: aAssociation key) setTestSelector: aAssociation value).
	result := testcase runInClientside.
	self add: (OrcaText new text: '<br/>' , aAssociation key, ' >> ', aAssociation value, ' with result: ', (self resultStringFor: result)   ).  
	
	^ result! !
